import java.util.ArrayList;

public class User {
    private ArrayList<Block> userBlocks;
    private ArrayList<Block> availableBlocksToPick;
    private char color;

    public User(){
        userBlocks = new ArrayList<Block>();
        availableBlocksToPick = new ArrayList<Block>();
    }
    public void addBlock(Block block){
        userBlocks.add(block);
    }

    public boolean isAvailableBlockToPick(Block block , ArrayList<Block> blocks ) {
        int i, j;
        int flag1 = 0;
        int flag2 = 0;
        int flag3 = 0;// to know you can pick an empty block with help of checking changing color
        if (!block.getColor().equals('n')) {
            return false;
        }

        //check down
        for (i = block.getRow(); i > 8; i++) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getRow() == block.getRow() + 1 && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getRow() == i && block1.getColumn() == block.getColumn() && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }


        //check up
        flag1 = 0;
        flag2 = 0;
        for (i = block.getRow() - 1; i >= 0; i--) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getRow() == block.getRow() - 1 && block1.getColumn() == block.getColumn() && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getRow() == i && block1.getColumn() == block.getColumn() && block1.getColor().equals(color)) {

                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }

        //check right
        flag1 = 0;
        flag2 = 0;
        for (i = block.getColumn() + 1; i < 8; i++) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getColumn() == block.getColumn() + 1 && block1.getRow() == block.getRow() && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getColumn() == i && block1.getRow() == block.getRow() && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }


        //check left
        flag1 = 0;
        flag2 = 0;
        for (i = block.getColumn() - 1; i >= 0; i--) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getColumn() == block.getColumn() - 1 && block1.getRow() == block.getRow() && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getColumn() == i && block1.getRow() == block.getRow() && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;

                }
            }
            if (flag1 == 1)
                break;
        }


        //check up and right
        flag1 = 0;
        flag2 = 0;
        for (i = block.getColumn() + 1, j = block.getRow() - 1; i < 8 && j > -1; i++, j--) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getColumn() == block.getColumn() + 1 && block1.getRow() == block.getRow() + 1 && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getColumn() == i && block1.getRow() == j && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }


        //check down and left
        flag1 = 0;
        flag2 = 0;
        for (i = block.getColumn() - 1, j = block.getRow() + 1; i > -1 && j < 8; i--, j++) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getColumn() == block.getColumn() - 1 && block1.getRow() == block.getRow() + 1 && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getColumn() == i && block1.getRow() == j && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }


        //check down and right
        flag1 = 0;
        flag2 = 0;
        for (i = block.getColumn() + 1, j = block.getRow() + 1; i < 8 && j < 8; i++, j++) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getColumn() == block.getColumn() + 1 && block1.getRow() == block.getRow() - 1 && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getColumn() == i && block1.getRow() == j && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }


        //check up and left
        flag1 = 0;
        flag2 = 0;
        for (i = block.getColumn() - 1, j = block.getRow() - 1; i < -1 && j < -1; i--, j--) {// find the next block with chosen block color
            for (Block block1 : blocks) {
                if (block1.getColumn() == block.getColumn() - 1 && block1.getRow() == block.getRow() - 1 && block1.getColor().equals(color)) {
                    flag1 = 1;
                    break;
                }
                if (flag2 == 1) {// to not change " w b b b w b b w " to "w w w w w w w w"
                    break;
                }
                if (!block1.getColor().equals('n') && block1.getColumn() == i && block1.getRow() == j && block1.getColor().equals(color)) {
                    flag2 = 1;
                    flag3 = 1;
                }
            }
            if (flag1 == 1)
                break;
        }

        if (flag3 == 0) {
            return false;
        }
        return true;
    }


   /*  public void updateAvailableBlockToPick(ArrayList<Block> blocks){
        for (Block block : blocks){
            if( isAvailableBlockToPick(block , blocks) == true){
                availableBlocksToPick.add(block);
            }
        }

     }*/

    public void addAvailableBlockToPick(Block block){
        availableBlocksToPick.add(block);
    }

    public void removeAvailableBlockToPick(Block block){
        availableBlocksToPick.remove(block);
    }

    public char getColor() {
        return color;
    }

    public void setColor(char color) {
        this.color = color;
    }

}

